"""
Pyweek22 entry
Theme: "You can't let him in here.

to do
    bounce
    change direction
    trigger sound
    
    add sounds and voices

    add text

game idea
    you can't let the Rushing Ambassador in the War Room because he will see the big board.
    your boss the P resident wants to let him in

    try to keep out the ambassador until the doomsday machine goes off.
    if you are inside and he is outside, then you win
    if he gets inside, it is a tie
    if he gets in and then leaves, you lose
    that is because he saw the big board

    the ambassador is trying to get into the warroom to see the big board
    don't trigger the doomsday machine and
    don't fall into a mineshaft gap
    watch out for flourinated water, drink only pure rain water to 
    maintain the purity of your bodily fluids

    by the way, you are probably insane/psychotic

    pick up a chair to block the entrance
    order guards to stop the ambassador
    the p resident will order them away

    planes fly to their targets
    enter the code to recall them

    you get interrupted when your lover calls
    so don't pick up the phone when it rings

"""
from __future__ import division
import pygame
from math import pow, sqrt
try:
    from . import ptext
except:
    pass
try:
    from . import printhelp
except:
    pass
try:
    from . import bomber_intro
except:
    pass

# moved datapath declaration here and put it
# at the bottom for local testing

datapath = 'data/'

def main():

    # setup timing
    clock = pygame.time.Clock()
    FRAMES_PER_SECOND = 30
    deltat = clock.tick(FRAMES_PER_SECOND)

    black = (0,0,0)
    white = (255, 255, 255)
    red = (255,0,0)
    green = (0,255,0)
    blue = (0,0,255)
    darkBlue = (0,0,128)
    pink = (255,200,200)
    grey = (196, 196, 196)
    grey = (200, 200, 200)

    # a surface
    pygame.init()
    screen_size = (1028, 768)
    screen = pygame.display.set_mode(screen_size)

    # draw the war room
    wt = 4  # wall thickness
    wx0 = 40
    wx1 = ((screen_size[0] - 2 * wx0) / 2) - 40
    wx2 = wx1 + 80
    wy = 120
    wxx = screen_size[0] - 2 * wx0
    wyy = screen_size[1] - 2 * wy

    wr_box = (wx0, wy, wxx, wyy) # to check for collisions inside 
    wr_points = [(wx1, wy),(wx0,wy), (wx0, wyy), (wxx, wyy), (wxx, wy), (wx2, wy)]
    pygame.draw.lines(screen, black, False, wr_points, wt)

    # define the foyer
    ft = 4  # wall thickness
    fx = screen_size[0] // 5
    fy = 0
    fxx = fx * 4
    fyy = wy # top of war room

    screen.fill(grey)
    pygame.display.update()

    bomber_intro.bomber_intro(screen_size, screen, wr_points, wt)

    # print instructions
    printhelp.printhelp()
    pygame.display.flip()

    running = True
    while running:
        # timing
        clock.tick(FRAMES_PER_SECOND)
        # handle events
        events = pygame.event.get()
        for event in events:
            if event.type == pygame.KEYDOWN:
                # when ESC is pressed end game
                if event.type == pygame.QUIT:
                    running = False    
                elif event.type == pygame.KEYDOWN and event.key == pygame.K_ESCAPE:
                    running = False
    
    # load the rushing ambassador
    ambassadorimage = datapath + 'amb003.png'
    ambassador = pygame.image.load(ambassadorimage)
    ambassadorrect = ambassador.get_rect()

    # define a rectangle for the ambassador's waiting room

    # get ambassador away from edge before collision detection
    ambassadorrect.x = fx + (fxx - fx) / 2
    ambassadorrect.y = fy + (fyy - fy) / 2

    if False:
        # print the ambassador's vitals
        print ('x, y', ambassadorrect.x, ambassadorrect.y,)
        print ('center', ambassadorrect.centerx, ambassadorrect.centery, )
        print ('center', ambassadorrect.center)
        print ('left, right', ambassadorrect.left, ambassadorrect.right)
        print ('top, bottom', ambassadorrect.top, ambassadorrect.bottom)
        print ('topleft, bottomright', ambassadorrect.topleft, ambassadorrect.bottomright)
        print ('width, height', ambassadorrect.width, ambassadorrect.height)

    # get a chair
    chairimage = datapath + 'chair002.png'
    chair = pygame.image.load(chairimage)
    chairrect = chair.get_rect()
    # put the first chair in the middle
    chairrect.x = screen_size[0]//2
    chairrect.y = screen_size[1]//2

    # get a raindrop
    rainimage = datapath + 'rain001.png'
    rain = pygame.image.load(rainimage)
    rainrect = rain.get_rect()
    # put the first rain to the left
    rainrect.x = wx0 + int((wxx - wx0) / 100)
    rainrect.y = wy + 0.35 * (wyy - wy)

    # get a tapwater
    tapimage = datapath + 'tap001.png'
    tap = pygame.image.load(tapimage)
    taprect = tap.get_rect()
    # put the first tap to the left
    taprect.x = wx0 + int((wxx - wx0) / 100)
    taprect.y = wy + 0.30 * (wyy - wy)

    # get a general
    genimage = datapath + 'gen002.png'
    gen = pygame.image.load(genimage)
    genrect = gen.get_rect()
    # put the first gen in the path of the tap water
    genrect.x = wxx - int((wxx - wx0) / 20)
    genrect.y = wy + 0.30 * (wyy - wy)

    # background music
    pygame.mixer.music.load(datapath + 'johnny.wav')
    pygame.mixer.music.play(10)
    ring_complete = pygame.USEREVENT + 1
    pygame.mixer.music.set_endevent(ring_complete)

    # starting speeds 
    #for ambassador
    x = 1.5
    y = 3
    # for general
    gx = 0
    gy = 0
    # for chair
    cx = 0
    cy = 0
    # for rain water
    rx = 3
    ry = 0
    # for tap water
    tx = 4
    ty = 0
    # gradually reduce speed for some objects
    spd_loss = 0.005

    # doomsday clock
    dc = 255000

    gen_strength = 3
    
    amb_state = 0 # ambassador outside
    amb_hit_bot = 0

    chair_up = False
    ambassador_outside = True
    running = True
    while running:
        # timing
        clock.tick(FRAMES_PER_SECOND)
        p = False   # pick up chair
        d = False   # drop chair
        screen.fill(grey)
        # draw the war room
        pygame.draw.lines(screen, black, False, wr_points, wt)
        # move the ambassador
        ambassadorrect = ambassadorrect.move([x,y])
        screen.blit(ambassador, ambassadorrect)
        # move the general
        genrect = genrect.move([gx, gy])
        screen.blit(gen, genrect)
        # move the chair
        if chair_up:
            # this happens when the general picks up the chair
            chairrect.x = genrect.x
            chairrect.y = genrect.y
        else:
            # this happens when the ambassador bumps the chair
            chairrect = chairrect.move([cx, cy])
            # the chair should gradually reduce speed
            cx, cy = reduce_spd(cx, cy, 10 * spd_loss)
        screen.blit(chair, chairrect)

        # move the rainwater
        # the rainwater moves to the right and starts over when it hits the wall
        rainrect = rainrect.move([rx, ry])
        if rainrect.centerx  >= wxx:
            rainrect.x = wx0
        screen.blit(rain, rainrect)

        # move the tap water
        # the tap water moves to the right and starts over when it hits the wall
        taprect = taprect.move([tx, ty])
        if taprect.centerx >= wxx:
            taprect.x = wx0
        screen.blit(tap, taprect)

        # print while running
        # general's strength
        ptext.draw("General's Strength = " + str(gen_strength), (screen_size[0]/2, screen_size[1] - 65), color="black")
        if gen_strength < 3:
            ptext.draw("Too weak to pick up a chair.", (screen_size[0]/2, screen_size[1] - 50), color="black")
            ptext.draw("Drink Rain Water.", (screen_size[0]/2, screen_size[1] - 35), color="black")
        # ptext.draw("General's position = " + str(genrect.centerx), (screen_size[0]/2, screen_size[1] - 20), color="black")        

        # doomsday clock
        dc -= 33
        if dc < 0:
            running = False

        dc_color = max(dc // 1000, 0)
        ptext.draw('Dooms', (screen_size[0] - 80, 10), color=(dc_color, dc_color, dc_color))
        ptext.draw(' Day', (screen_size[0] - 80, 26), color=(dc_color, dc_color, dc_color))
        ptext.draw(str(dc), (screen_size[0] - 80, 42), color=(dc_color, dc_color, dc_color))

        pygame.display.flip()

        # the general should gradually reduce speed
        gx, gy = reduce_spd(gx, gy, spd_loss)

        # handle events
        events = pygame.event.get()
        for event in events:
            if event.type == ring_complete:
                pygame.mixer.music.load(datapath + 'johnny.wav')
                pygame.mixer.music.play(10)
            if event.type == pygame.KEYDOWN:
                if event.key == pygame.K_LEFT:
                    if 0 < gx < 1:
                        gx = 0
                    else:
                        gx -= 1
                elif event.key == pygame.K_RIGHT:
                    if -1 < gx < 0:
                        gx = 0
                    else:
                        gx += 1
                elif event.key == pygame.K_UP:
                    if 0 < gy < 1:
                        gy = 0
                    else:
                        gy -= 1
                elif event.key == pygame.K_DOWN:
                    if -1 < gy < 0:
                        gy = 0
                    else:
                        gy += 1
                elif  event.key == pygame.K_d:
                    # drop chair
                    d = True
                elif  event.key == pygame.K_p:
                    # pickup chair
                    p = True
                # when ESC is pressed end game
                elif event.type == pygame.QUIT:
                    running = False    
                elif event.type == pygame.KEYDOWN and event.key == pygame.K_ESCAPE:
                    running = False

        if ambassador_outside:
            # bounce on collision
            if ambassadorrect.left <= fx:
                x = abs(x)
                # speed up the ambassodor
                x *= 1.7
                y *= 1.7
                x = max(min(x, 5), -5)
                y = max(min(y, 5), -5)
            elif ambassadorrect.right >= fxx:
                x = -1 * abs(x)
            if check_hit_horiz(0, ambassadorrect):
                # hit the outside game wall
                y = abs(y)
                # pygame.mixer.music.stop()
                # pygame.mixer.music.load(datapath + 'Phone_Ringing.wav')
                # pygame.mixer.music.play(0)
            
            elif check_hit_wr_door(wr_points, ambassadorrect):
                # the ambassador is near the door
                if check_hit_two_small_objects(ambassadorrect.center, chairrect.center, tolerance = 30):
                    # check if a chair is blocking the door
                    # both the ambassodor and the chair will bounce
                    # if would be nice to check the angle of impact
                    y = -1 * y
                    chair_up = False
                    cx = -6
                    cy = 6
            elif y > 0 and check_hit_horiz(wy, ambassadorrect):
                # hit the war room
                y = -1 * abs(y)

            if check_hit_horiz(wr_box[3], ambassadorrect):
                # one more check because I think there is a flaw
                # in my logic that sometimes lets the ambassador
                # run off the bottom on the screen
                y = -1 * abs(y)

        else:
            # ambassador is inside
            # this keeps the ambassador inside the war room
            if check_hit_horiz(wr_box[3], ambassadorrect):
                y = -1 * abs(y)
                amb_hit_bot += 1
                if amb_hit_bot > 1:
                    # aim for the exit
                    x = y * (ambassadorrect.x - (wxx - wx0) / 2) / (ambassadorrect.y - wy)
                    if 0 < x < 1:
                        y = y / x
                        x = 1
                    elif -1 < x < 0:
                        y = -y / x
                        x = -1
            elif not check_hit_wr_door(wr_points, ambassadorrect):
                # the ambassador is not near the door
                if check_hit_horiz(wr_box[1], ambassadorrect):
                    y = abs(y)

            if check_hit_vert(wr_box[0], ambassadorrect):
                x = abs(x)
            elif check_hit_vert(wr_box[2], ambassadorrect):
                x = -1 * abs(x)
        if ambassadorrect.top > wy:
            # the ambassador is inside
            ambassador_outside = False
            if amb_state == 0:
                amb_state = 1 # ambassador inside
        elif ambassadorrect.bottom < wy:
            ambassador_outside = True
            if amb_state == 1:
                amb_state = 2 # ambassador escaped
                dc = 0

        # see if the general hits anything
        # this keeps the general inside the war room
        if genrect.top <= wr_box[1]:
            gy = abs(gy)
        elif genrect.bottom >= wr_box[3]:
            gy = -1 * abs(gy)
        if genrect.left <= wr_box[0]:
            gx = abs(gx)
        elif genrect.right >= wr_box[2]:
            gx = -1 * abs(gx)
        if check_hit_two_small_objects(genrect.center, taprect.center, tolerance = 20):
            # hit by tapwater
            gen_strength -= 1
            gen_strength = max(0, gen_strength)

        if check_hit_two_small_objects(genrect.center, rainrect.center, tolerance = 20):
            # hit by rain water
            gen_strength += 1
            gen_strength = min(3, gen_strength)


        if p:
            # try to pick up chair
            if check_hit_two_small_objects(genrect.center, chairrect.center, tolerance = 30):
                if gen_strength > 2:
                    chair_up = True
        if d:
            #drop chair
            chair_up = False

    # if the clock counted down
    # check ambassador
    # if the ambassador never gets in, you win
    # if the ambassador gets in you tie
    # if the ambassador gets backout, you lose

    # at the end, check a few things
    # if the clock not completed
    # the esc key way pressed
    # try again later
    if dc > 0:
        printhelp.printend(0)
    else:
        screen.fill(grey)
        pygame.display.update()
        # draw the war room
        pygame.draw.lines(screen, black, False, wr_points, wt)

        if amb_state == 0:
            printhelp.printend(1)
        elif amb_state == 1:
            printhelp.printend(2)
        elif amb_state == 2:
            printhelp.printend(3)
        else:
            printhelp.printend(4)

    pygame.display.flip()
    running = True
    while running:
        # timing
        clock.tick(FRAMES_PER_SECOND)
        # handle events
        events = pygame.event.get()
        for event in events:
            if event.type == pygame.KEYDOWN:
                # when ESC is pressed end game
                if event.type == pygame.QUIT:
                    running = False    
                elif event.type == pygame.KEYDOWN and event.key == pygame.K_ESCAPE:
                    running = False

    pygame.quit()

def reduce_spd(gx, gy, spd_loss):
    # some objects gradually reduce speed
    if gx > 0:
        gx -= spd_loss
    elif gx < 0:
        gx += spd_loss
    if gy > 0:
        gy -= spd_loss
    elif gy < 0:
        gy += spd_loss
    return(gx, gy)


def check_hit_wr_door(wr_points, moving_rect):
    hit = False
    # check sides of door
    # wr_points = [(wx1, wy),(wx0,wy), (wx0, wyy), (wxx, wyy), (wxx, wy), (wx2, wy)]
    if wr_points[0][0] <=  moving_rect.left and moving_rect.right <= wr_points[5][0]:
        # the x value is inside the door
        hit = True
    return(hit)

def check_hit_horiz(horizontal_y_value, inner_rect):
    hit = False
    if abs(horizontal_y_value - inner_rect.top) <= 1 or \
        abs(horizontal_y_value - inner_rect.bottom) <= 1:
        hit = True
    return(hit)

def check_hit_vert(horizontal_x_value, inner_rect):
    hit = False
    if abs(horizontal_x_value - inner_rect.left) <= 1 or \
        abs(horizontal_x_value - inner_rect.right) <= 1:
        hit = True
    return(hit)

def check_hit_inside_box(box_dimensions, rect_center, tolerance = 0):
    # box dimensions is a tuple (minx, miny, maxx, maxy)
    # check for collision with the center of the image
    # tolerance is how close to the center it can get
    hit = False
    if not((box_dimensions[0] + tolerance < rect_center[0] < box_dimensions[2] - tolerance) and \
        (box_dimensions[1] + tolerance < rect_center[1] < box_dimensions[3] - tolerance)):
        hit = True
    return(hit)

def check_hit_two_small_objects(rect_center1, rect_center2, tolerance = 0):
    # rect_center is a tuple (x, y)
    # check for collision with the center of the images
    # tolerance is how close to the center they can get
    hit = False
    if not \
        sqrt(pow(rect_center1[0] - rect_center2[0], 2) \
            + pow(rect_center1[1] - rect_center2[1], 2)) > tolerance:
        hit = True
    return(hit)

if __name__ == "__main__":
    # this path is for loacl testing
    datapath = '../data/'
    import ptext
    import printhelp
    import bomber_intro
    main()
